<?php
date_default_timezone_set('Asia/Shanghai');
header('Content-Type: application/json');

$db_host = "localhost";
$db_user = "jz_cuaye_cn";    
$db_pass = "QJdA6jyjTrMheSdi";
$db_name = "jz_cuaye_cn";

try {
    if (!isset($_GET['id']) || !is_numeric($_GET['id'])) {
        throw new Exception("无效的请求参数");
    }
    $id = (int)$_GET['id'];
    if ($id <= 0) throw new Exception("非法ID: $id");

    $conn = new mysqli($db_host, $db_user, $db_pass, $db_name);
    if ($conn->connect_error) {
        throw new Exception("数据库连接失败: " . $conn->connect_error);
    }

    $conn->begin_transaction();

    try {
        // 获取原记录时间
        $stmt = $conn->prepare("SELECT datetime FROM bills WHERE id = ?");
        $stmt->bind_param("i", $id);
        $stmt->execute();
        $result = $stmt->get_result();
        if ($result->num_rows === 0) throw new Exception("记录不存在");
        $datetime = $result->fetch_assoc()['datetime'];

        // 删除文件记录
        $date = new DateTime($datetime);
        $filePath = sprintf(
            "%s/zandan/%s/%syue/%s.txt",
            $_SERVER['DOCUMENT_ROOT'],
            $date->format('Y'),
            $date->format('m'),
            $date->format('d')
        );

        if (file_exists($filePath)) {
            $content = file_get_contents($filePath);
            $pattern = "/#ID:$id\n用途：(.*?)\n金额：￥(.*?)\n时间：(.*?)\n\n/s";
            $newContent = preg_replace($pattern, '', $content, -1, $count);
            if ($count > 0) file_put_contents($filePath, $newContent);
        }

        // 删除数据库记录
        $stmt = $conn->prepare("DELETE FROM bills WHERE id = ?");
        $stmt->bind_param("i", $id);
        $stmt->execute();
        if ($stmt->affected_rows === 0) throw new Exception("未找到可删除的记录");

        $conn->commit();
        echo json_encode(['status' => 'success', 'message' => '删除成功']);

    } catch (Exception $e) {
        $conn->rollback();
        throw $e;
    }

} catch (Exception $e) {
    http_response_code(500);
    echo json_encode([
        'status' => 'error',
        'message' => $e->getMessage()
    ]);
} finally {
    if (isset($conn)) $conn->close();
}