<?php
// ========== 数据库配置 ==========
date_default_timezone_set('Asia/Shanghai');
$db_host = "localhost";
$db_user = "jz_cuaye_cn";    
$db_pass = "QJdA6jyjTrMheSdi";
$db_name = "jz_cuaye_cn";

// 创建数据库连接
$conn = new mysqli($db_host, $db_user, $db_pass);
if ($conn->connect_error) die("数据库连接失败: " . $conn->connect_error);

// 自动创建数据库和表
$conn->query("CREATE DATABASE IF NOT EXISTS $db_name");
$conn->select_db($db_name);
$conn->query("CREATE TABLE IF NOT EXISTS bills (
    id INT AUTO_INCREMENT PRIMARY KEY,
    name VARCHAR(255) NOT NULL,
    amount DECIMAL(10,2) NOT NULL,
    datetime DATETIME NOT NULL
)");

// ========== 处理筛选参数 ==========
$year = isset($_GET['year']) && $_GET['year'] !== '' ? intval($_GET['year']) : null;
$month = isset($_GET['month']) && $_GET['month'] !== '' ? intval($_GET['month']) : null;

// 构建查询条件
$whereClause = [];
if ($year !== null) $whereClause[] = "YEAR(datetime) = $year";
if ($month !== null) $whereClause[] = "MONTH(datetime) = $month";
$where = empty($whereClause) ? '' : 'WHERE ' . implode(' AND ', $whereClause);

// ========== 计算总支出 ==========
$currentYear = date('Y');
$currentMonth = date('m');
if ($year === null && $month === null) {
    $monthTotal = $conn->query("SELECT COALESCE(SUM(amount), 0) AS total FROM bills WHERE YEAR(datetime) = $currentYear AND MONTH(datetime) = $currentMonth")->fetch_assoc()['total'] ?? 0;
} else {
    $monthTotal = $conn->query("SELECT COALESCE(SUM(amount), 0) AS total FROM bills $where")->fetch_assoc()['total'] ?? 0;
}

// ========== 获取记录 ==========
$recordsQuery = "SELECT * FROM bills " . ($where ?: '') . " ORDER BY datetime DESC";
$records = $conn->query($recordsQuery);

// 获取可用年份
$yearsResult = $conn->query("SELECT YEAR(datetime) AS year FROM bills GROUP BY year ORDER BY year DESC");
?>
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
    <title>全功能记账本</title>
    <style>
        /* 完整CSS样式 */
        * { box-sizing: border-box; margin: 0; padding: 0; font-family: -apple-system, sans-serif; }
        body { background: #f5f5f5; padding: 15px; line-height: 1.6; }
        .header { background: #2c3e50; color: white; padding: 20px; border-radius: 12px; margin-bottom: 20px; }
        .total { font-size: 22px; color: #e74c3c; margin-top: 10px; }
        .input-form { background: white; padding: 15px; border-radius: 12px; margin-bottom: 20px; }
        input, button { width: 100%; padding: 12px; margin: 8px 0; border: 1px solid #ddd; border-radius: 8px; font-size: 16px; }
        button { background: #3498db; color: white; border: none; cursor: pointer; transition: opacity 0.3s; }
        button:active { opacity: 0.8; }
        .record { background: white; padding: 15px; margin: 15px 0; border-radius: 12px; position: relative; }
        .btn-group { position: absolute; right: 10px; bottom: 10px; display: flex; gap: 8px; }
        .edit-btn { background: #3498db; padding: 8px 15px; border-radius: 6px; }
        .delete-btn { background: #e74c3c; padding: 8px 15px; border-radius: 6px; }
        @media (max-width: 480px) { 
            .record { padding: 12px 80px 12px 12px; }
            .btn-group { bottom: 8px; right: 8px; }
            button { padding: 6px 12px; font-size: 12px; }
        }
        .loading { color: #3498db; text-align: center; padding: 10px; }
        .filter-box { background: white; padding: 15px; border-radius: 12px; margin-bottom: 20px; display: flex; gap: 10px; flex-wrap: wrap; }
        .filter-box select, .filter-box button { padding: 10px; border: 1px solid #ddd; border-radius: 8px; font-size: 14px; }
        .filter-box button { background: #3498db; color: white; border: none; }
        .month-divider { background: #f8f9fa; color: #666; padding: 8px 15px; margin: 20px 0; border-radius: 6px; font-weight: bold; box-shadow: 0 2px 4px rgba(0,0,0,0.1); }
    </style>
</head>
<body>
    <div class="header">
        <h1>📱 全功能记账本</h1>
        <div class="total">
            <?php if ($year !== null && $month !== null): ?>
                <?= date('Y年m月', mktime(0,0,0,$month,1,$year)) ?>总支出：
            <?php elseif ($year === null && $month === null): ?>
                当月（<?= date('Y年m月') ?>）<br>总支出：
            <?php else: ?>
                全部总支出：
            <?php endif; ?>
            ￥<?= number_format($monthTotal, 2) ?>
        </div>
    </div>

    <!-- 筛选表单 -->
    <form class="filter-box" method="get">
        <select name="year">
            <option value="">选择年份</option>
            <?php while($y = $yearsResult->fetch_assoc()): ?>
                <option value="<?=$y['year']?>" <?= $year == $y['year'] ? 'selected' : '' ?>>
                    <?=$y['year']?>年
                </option>
            <?php endwhile; ?>
        </select>
        <select name="month">
            <option value="">选择月份</option>
            <?php for($m=1; $m<=12; $m++): ?>
                <option value="<?=$m?>" <?= $month == $m ? 'selected' : '' ?>>
                    <?=str_pad($m,2,'0',STR_PAD_LEFT)?>月
                </option>
            <?php endfor; ?>
        </select>
        <button type="submit">筛选</button>
        <?php if($year !== null || $month !== null): ?>
            <a href="?" style="padding:10px; color:#666;">清除筛选</a>
        <?php endif; ?>
    </form>

    <!-- 输入表单 -->
    <form class="input-form" id="addForm">
        <input type="date" name="date" id="dateInput" required>
        <input type="time" name="time" id="timeInput" required>
        <input type="text" name="name" placeholder="消费用途（如：午餐）" required>
        <input type="number" name="amount" step="0.01" placeholder="金额（元）" required>
        <button type="submit" name="add">💾 立即保存</button>
    </form>

    <!-- 记录列表 -->
    <div id="records">
        <?php
        $currentGroup = null;
        while($row = $records->fetch_assoc()): 
            $recordYear = date('Y', strtotime($row['datetime']));
            $recordMonth = date('m', strtotime($row['datetime']));
            $groupKey = "$recordYear-$recordMonth";
            
            if ($year === null && $month === null && $groupKey !== $currentGroup):
                $currentGroup = $groupKey;
        ?>
            <div class="month-divider" data-month="<?= $groupKey ?>">
                📅 <?= date('Y年m月', strtotime($row['datetime'])) ?>
            </div>
        <?php endif; ?>
        
        <div class="record" data-datetime="<?= $row['datetime'] ?>" data-month="<?= $groupKey ?>">
            <div style="color: #666; font-size:14px;"><?= date("m-d H:i", strtotime($row['datetime'])) ?></div>
            <div style="font-weight:600; margin:5px 0;"><?= $row['name'] ?></div>
            <div style="color:#c0392b; font-size:18px; font-weight:700;">￥<?= number_format($row['amount'], 2) ?></div>
            <div class="btn-group">
                <button class="edit-btn" onclick="showEdit(<?= $row['id'] ?>)">✏️ 修改</button>
                <button class="delete-btn" onclick="confirmDelete(<?= $row['id'] ?>)">🗑️ 删除</button>
            </div>
        </div>
        <?php endwhile; ?>
    </div>

    <!-- 编辑弹窗 -->
    <div id="editBox" style="display:none; position:fixed; top:50%; left:50%; transform:translate(-50%,-50%); background:white; padding:25px; border-radius:15px; width:90%; max-width:500px; box-shadow:0 10px 30px rgba(0,0,0,0.2); z-index:1000;">
        <h3 style="margin-bottom:20px; color:#333;">编辑记录</h3>
        <form onsubmit="return saveChange(event)">
            <input type="hidden" id="editId">
            <input type="datetime-local" id="editTime" style="width:100%; margin-bottom:15px; padding:10px;" required>
            <input type="text" id="editName" placeholder="用途" style="width:100%; margin-bottom:15px; padding:10px;" required>
            <input type="number" id="editAmount" step="0.01" placeholder="金额" style="width:100%; margin-bottom:20px; padding:10px;" required>
            <div style="display:flex; gap:10px;">
                <button type="submit" style="flex:1; background:#27ae60; padding:12px;">💾 保存</button>
                <button type="button" onclick="closeEdit()" style="flex:1; background:#e74c3c; padding:12px;">❌ 取消</button>
            </div>
        </form>
    </div>

    <script>
        // ====== 日期记忆功能 ======
        const dateInput = document.getElementById('dateInput');
        const timeInput = document.getElementById('timeInput');

        // 初始化日期和时间
        const loadSavedDateTime = () => {
            // 检查用户是否手动选择过日期
            const userHasSelected = localStorage.getItem('userHasSelectedDate') === 'true';
            
            if (userHasSelected) {
                // 用户已选择过日期：读取保存的值
                dateInput.value = localStorage.getItem('lastSelectedDate');
                timeInput.value = localStorage.getItem('lastSelectedTime');
            } else {
                // 首次加载：使用当前北京时间
                const now = new Date();
                dateInput.value = now.toISOString().split('T')[0];
                timeInput.value = now.toLocaleTimeString('zh-CN', { 
                    hour: '2-digit', 
                    minute: '2-digit', 
                    hour12: false 
                });
            }
        };

        // 保存日期和时间到 localStorage
        const saveDateTime = () => {
            localStorage.setItem('lastSelectedDate', dateInput.value);
            localStorage.setItem('lastSelectedTime', timeInput.value);
            localStorage.setItem('userHasSelectedDate', 'true'); // 标记用户已选择过日期
        };

        // 初始化加载日期
        loadSavedDateTime();

        // 监听日期和时间变化
        dateInput.addEventListener('change', saveDateTime);
        timeInput.addEventListener('change', saveDateTime);

        // ====== AJAX提交表单 ======
        document.getElementById('addForm').addEventListener('submit', async function(e) {
            e.preventDefault();
            const btn = this.querySelector('button[type="submit"]');
            btn.disabled = true;
            btn.innerHTML = '保存中...';

            const formData = new FormData(this);
            try {
                const response = await fetch('add_record.php', { method: 'POST', body: formData });
                const result = await response.json();

                if (result.status === 'success') {
                    // 动态插入新记录到顶部
                    const newRecord = `
                        <div class="record" data-datetime="${result.data.datetime}" data-month="${result.data.monthKey}">
                            <div style="color: #666; font-size:14px;">${result.data.displayTime}</div>
                            <div style="font-weight:600; margin:5px 0;">${result.data.name}</div>
                            <div style="color:#c0392b; font-size:18px; font-weight:700;">￥${result.data.amount}</div>
                            <div class="btn-group">
                                <button class="edit-btn" onclick="showEdit(${result.data.id})">✏️ 修改</button>
                                <button class="delete-btn" onclick="confirmDelete(${result.data.id})">🗑️ 删除</button>
                            </div>
                        </div>
                    `;
                    document.getElementById('records').insertAdjacentHTML('afterbegin', newRecord);

                    // 清空「用途」和「金额」输入框
                    document.querySelector('input[name="name"]').value = '';
                    document.querySelector('input[name="amount"]').value = '';

                    // 更新月份分隔线
                    updateMonthDividers();
                }
            } catch (error) {
                alert('保存失败: ' + error.message);
            } finally {
                btn.disabled = false;
                btn.innerHTML = '💾 立即保存';
            }
        });

        // ====== 删除记录 ======
        async function confirmDelete(id) {
            if (!confirm('⚠️ 确定删除此记录？')) return;

            const btn = event.target;
            const originalHTML = btn.innerHTML;
            btn.innerHTML = '<div class="loading">删除中...</div>';
            btn.disabled = true;

            try {
                const response = await fetch(`delete.php?id=${id}`);
                const data = await response.json();

                if (data.status === 'success') {
                    const record = btn.closest('.record');
                    const monthKey = record.dataset.month;

                    // 移除记录
                    record.style.opacity = '0';
                    setTimeout(() => record.remove(), 300);

                    // 移除空月份的分隔线
                    const remaining = document.querySelectorAll(`.record[data-month="${monthKey}"]`);
                    if (remaining.length === 0) {
                        const divider = document.querySelector(`.month-divider[data-month="${monthKey}"]`);
                        if (divider) divider.remove();
                    }

                    // 更新总支出
                    await updateTotal();
                }
            } catch (error) {
                alert('删除失败: ' + error.message);
            } finally {
                btn.innerHTML = originalHTML;
                btn.disabled = false;
            }
        }

        // ====== 修复月份分隔线逻辑 ======
        function updateMonthDividers() {
            const recordsContainer = document.getElementById('records');
            const records = Array.from(document.querySelectorAll('.record'));

            // 1. 移除所有现有分隔线
            document.querySelectorAll('.month-divider').forEach(div => div.remove());

            // 2. 按时间降序排序记录
            records.sort((a, b) => {
                const dateA = new Date(a.dataset.datetime);
                const dateB = new Date(b.dataset.datetime);
                return dateB - dateA; // 降序排列
            });

            // 3. 清空容器并重新插入排序后的记录
            recordsContainer.innerHTML = '';
            let lastMonthKey = null;

            records.forEach(record => {
                const datetime = record.dataset.datetime;
                const date = new Date(datetime);
                const monthKey = `${date.getFullYear()}-${String(date.getMonth() + 1).padStart(2, '0')}`;

                // 插入月份分隔线（仅当月份变化时）
                if (monthKey !== lastMonthKey) {
                    const divider = document.createElement('div');
                    divider.className = 'month-divider';
                    divider.dataset.month = monthKey;
                    divider.innerHTML = `📅 ${date.getFullYear()}年${String(date.getMonth() + 1).padStart(2, '0')}月`;
                    recordsContainer.appendChild(divider);
                    lastMonthKey = monthKey;
                }

                // 插入记录
                recordsContainer.appendChild(record);
            });
        }

        // ====== 其他原有函数 ======
        let currentEditId = null;

        async function showEdit(id) {
            try {
                const response = await fetch(`get_record.php?id=${id}`);
                const data = await response.json();
                document.getElementById('editId').value = id;
                document.getElementById('editTime').value = data.datetime.replace(' ', 'T');
                document.getElementById('editName').value = data.name;
                document.getElementById('editAmount').value = data.amount;
                document.getElementById('editBox').style.display = 'block';
                currentEditId = id;
            } catch (error) {
                alert('获取数据失败: ' + error.message);
            }
        }

        function closeEdit() {
            document.getElementById('editBox').style.display = 'none';
            currentEditId = null;
        }

        async function saveChange(event) {
            event.preventDefault();
            const btn = event.target.querySelector('button[type="submit"]');
            btn.disabled = true;
            btn.innerHTML = '保存中...';

            const formData = new FormData();
            formData.append('id', document.getElementById('editId').value);
            formData.append('datetime', document.getElementById('editTime').value.replace('T', ' '));
            formData.append('name', document.getElementById('editName').value);
            formData.append('amount', document.getElementById('editAmount').value);

            try {
                const response = await fetch('update.php', { method: 'POST', body: formData });
                const result = await response.json();
                if (result.status === 'success') {
                    location.reload();
                } else {
                    throw new Error(result.message || '保存失败');
                }
            } catch (error) {
                alert('保存失败: ' + error.message);
            } finally {
                btn.disabled = false;
                btn.innerHTML = '💾 保存';
            }
        }

        async function updateTotal() {
            try {
                const response = await fetch('get_total.php?_=' + Date.now());
                const data = await response.json();
                document.querySelector('.total').innerHTML = `￥${data.total}`;
            } catch (error) {
                console.error('更新总支出失败:', error);
            }
        }
    </script>
</body>
</html>
<?php $conn->close(); ?>